## python-autobahn 24.4.2+dfsg1

=== Makefile ===
.PHONY: test docs pep8 build

WHEELS=https://crossbarbuilder.s3.eu-central-1.amazonaws.com/wheels
XBRNETWORK=${HOME}/.local/bin/xbrnetwork

all:
	@echo "Targets:"
	@echo ""
	@echo "   clean            Cleanup"
	@echo "   install          Local install"
	@echo "   publish          Clean build, register and publish to PyPi"
	@echo "   test             Run unit tests"
	@echo "   flake8           Run flake8 code checking"
	@echo ""

# deprecated with v21.2.1 (ABI files are no longer bundled in this package)
abi_files:
	curl -s https://xbr.network/lib/abi/xbr-protocol-latest.zip -o /tmp/xbr-protocol-latest.zip
	unzip -t /tmp/xbr-protocol-latest.zip
	rm -rf ${PWD}/autobahn/xbr/contracts
	unzip /tmp/xbr-protocol-latest.zip -d ${PWD}/autobahn/xbr/contracts

# install locally
install:
	-pip uninstall -y pytest_asyncio # remove the broken shit
	-pip uninstall -y pytest_cov # remove the broken shit
	# enforce use of bundled libsodium
	AUTOBAHN_USE_NVX=1 SODIUM_INSTALL=bundled pip install -e .[all]

build:
	-rm -f dist/*
	# AUTOBAHN_USE_NVX=0 python -m build
	AUTOBAHN_USE_NVX=1 python -m build
	ls -la dist

# upload to our internal deployment system
upload: clean
	AUTOBAHN_USE_NVX=0 python -m build
	aws s3 cp --acl public-read \
		dist/autobahn-*.whl \
		s3://fabric-deploy/autobahn/

# cleanup everything
clean: clean_docs clean_catalog
	-rm -f ./*.so
	-rm -rf ./docs/build
	-rm -rf ./.cache
	-rm -rf ./autobahn.egg-info
	-rm -rf ./build
	-rm -rf ./dist
	-rm -rf ./temp
	-rm -rf ./_trial_temp
	-rm -rf ./.tox
	-rm -rf ./.eggs
	-rm -rf ./htmlcov
	-rm -f  ./twisted/plugins/dropin.cache
	-find . -name "*dropin.cache.new" -type f -exec rm -f {} \;
	-find . -name ".pytest_cache" -type d -exec rm -rf {} \;
	-find . -name "*.tar.gz" -type f -exec rm -f {} \;
	-find . -name "*.egg" -type f -exec rm -f {} \;
	-find . -name "*.pyc" -type f -exec rm -f {} \;

	# Learn to love the shell! http://unix.stackexchange.com/a/115869/52500
	-find . \( -name "*__pycache__" -type d \) -prune -exec rm -rf {} +

clean_catalog:
	cd ./autobahn/xbr/test/catalog && make clean

rebuild_catalog:
	cd ./autobahn/xbr/test/catalog && make distclean && make build

# publish to PyPI
publish: clean
	AUTOBAHN_USE_NVX=0 python -m build
	twine upload dist/*

clean_docs:
	-rm -rf ./docs/_build
	-rm -rf ./docs/autoapi/

docs:
	tox -e sphinx

spelling:
	cd docs && sphinx-build -b spelling . _spelling

run_docs:
	twistd --nodaemon web --port=tcp:8090 --path=./docs/_build/


clean_wheels:
	rm -rf ./.wheels
	mkdir -p ./.wheels/

download_wheels:
	mkdir -p ./.wheels/
	rm -f ./.wheels/*.whl
	curl -o ./.wheels/txaio-latest-py2.py3-none-any.whl 	$(WHEELS)/txaio-latest-py2.py3-none-any.whl
	curl -o ./.wheels/zlmdb-latest-py2.py3-none-any.whl 	$(WHEELS)/zlmdb-latest-py2.py3-none-any.whl
	curl -o ./.wheels/xbr-latest-py2.py3-none-any.whl 		$(WHEELS)/xbr-latest-py2.py3-none-any.whl
	curl -o ./.wheels/autobahn-latest-py2.py3-none-any.whl 	$(WHEELS)/autobahn-latest-py2.py3-none-any.whl
	ls -la ./.wheels

build_this_wheel:
	mkdir -p ./.wheels/
	rm -f ./.wheels/autobahn*.whl
	pip3 wheel --no-deps --wheel-dir=./.wheels .
	mv .wheels/autobahn*.whl .wheels/autobahn-latest-py2.py3-none-any.whl
	ls -la ./.wheels

download_exe:
	curl -o $(XBRNETWORK) \
		https://download.crossbario.com/xbrnetwork/linux-amd64/xbrnetwork-latest
	chmod +x $(XBRNETWORK)
	$(XBRNETWORK) version

build_exe:
	tox -e buildexe

upload_exe:
	aws s3 cp --acl public-read \
		./dist/xbrnetwork \
		s3://download.crossbario.com/xbrnetwork/linux-amd64/${XBRNETWORK_EXE_FILENAME}
	aws s3 cp --acl public-read \
		./dist/xbrnetwork \
		s3://download.crossbario.com/xbrnetwork/linux-amd64/xbrnetwork-latest
	# aws s3api copy-object --acl public-read --copy-source \
	# 	download.crossbario.com/xbrnetwork/linux-amd64/${XBRNETWORK_EXE_FILENAME} \
	# 	--bucket download.crossbario.com \
	# 	--key xbrnetwork/linux-amd64/xbrnetwork-latest
	aws cloudfront create-invalidation \
		--distribution-id E2QIG9LNGCJSP9 --paths "/xbrnetwork/linux-amd64/*"

mypy:
	mypy --install-types --non-interactive autobahn

# WEB3_INFURA_PROJECT_ID must be defined for this
test_infura:
	time -f "%e" python -c "from web3.auto.infura import w3; print(w3.isConnected())"

test_xbr:
	USE_TWISTED=1 trial autobahn.xbr

test_xbr_cli:
	xbrnetwork
	xbrnetwork version
	xbrnetwork get-member
	xbrnetwork get-market --market=1388ddf6-fe36-4201-b1aa-cb7e36b4cfb3
	xbrnetwork get-actor
	xbrnetwork get-actor --market=1388ddf6-fe36-4201-b1aa-cb7e36b4cfb3

test_wamp_serializer:
	-USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_serializer
	-USE_ASYNCIO=1 pytest autobahn/wamp/test/test_wamp_serializer.py

test_xbr_schema:
	USE_TWISTED=1 trial autobahn.xbr.test.schema
	USE_ASYNCIO=1 pytest autobahn/xbr/test/schema

test_mnemonic:
	# python -m pytest -rsx autobahn/xbr/test/test_mnemonic.py
	USE_TWISTED=1 trial autobahn.xbr.test

test_nvx:
	python -m pytest -rsx autobahn/nvx/test
	USE_TWISTED=1 trial autobahn.nvx.test.test_utf8validator

test_styleguide:
	flake8 --statistics --max-line-length=119 -qq autobahn

# direct test via pytest (only here because of setuptools test integration)
test_pytest:
	USE_ASYNCIO=1 python -m pytest -c setup.cfg -rsvx autobahn/

test:
	tox -e flake8,py37-twtrunk,py37-asyncio

#test: flake8 test_twisted test_asyncio

# test under Twisted
test_twisted:
	USE_TWISTED=1 trial autobahn
#	WAMP_ROUTER_URL="ws://127.0.0.1:8080/ws" USE_TWISTED=1 trial autobahn

test_application_runner:
	USE_TWISTED=1 trial autobahn.twisted.test.test_tx_application_runner

test_util:
	USE_TWISTED=1 trial autobahn.test.test_util

test_rng:
	USE_TWISTED=1 trial autobahn.test.test_rng

test_serializer:
	USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_serializer

test_wamp_identifiers:
	USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_identifiers

test_tx_cryptobox:
	USE_TWISTED=1 trial autobahn.wamp.test.test_cryptobox

test_tx_choosereactor:
	USE_TWISTED=1 trial autobahn.twisted.test.test_choosereactor

test_cryptosign:
#	USE_ASYNCIO=1 trial autobahn.wamp.test.test_wamp_cryptosign
	USE_ASYNCIO=1 pytest -s -v -rfA --ignore=./autobahn/twisted autobahn/wamp/test/test_wamp_cryptosign.py
	USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_cryptosign

test_xbr_web3:
#	pytest -s -v -rfA autobahn/xbr/test/test_xbr_web3.py
	trial autobahn/xbr/test/test_xbr_web3.py

test_xbr_frealm:
#	pytest -s -v -rfA autobahn/xbr/test/test_xbr_frealm.py
	trial autobahn/xbr/test/test_xbr_frealm.py

test_wamp_scram:
	USE_ASYNCIO=1 trial autobahn.wamp.test.test_wamp_scram
	USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_scram

test_xbr_argon2:
	USE_ASYNCIO=1 trial autobahn.xbr.test.test_xbr_argon2
	USE_TWISTED=1 trial autobahn.xbr.test.test_xbr_argon2

test_xbr_config:
	USE_TWISTED=1 trial autobahn.xbr.test.test_xbr_config

test_transport_details:
	USE_ASYNCIO=1 trial autobahn.wamp.test.test_wamp_transport_details
	USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_transport_details

test_session_details:
	USE_ASYNCIO=1 trial autobahn.wamp.test.test_wamp_session_details
	USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_session_details

test_tx_protocol:
	USE_TWISTED=1 trial autobahn.twisted.test.test_tx_protocol

test_asyncio:
	USE_ASYNCIO=1 pytest -s -v -rfP --ignore=./autobahn/twisted autobahn
#	USE_ASYNCIO=1 pytest -s -v -rA --ignore=./autobahn/twisted ./autobahn/asyncio/test/test_aio_websocket.py
#	USE_ASYNCIO=1 pytest -s -v -rA --log-cli-level=info --ignore=./autobahn/twisted ./autobahn/asyncio/test/test_aio_websocket.py

test_cs1:
	USE_ASYNCIO=1 python -m pytest -s -v autobahn/wamp/test/test_cryptosign.py

test1:
	USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_uri_pattern
#	USE_TWISTED=1 trial autobahn.wamp.test.test_auth
#	USE_TWISTED=1 python -m pytest -s -v autobahn/wamp/test/test_auth.py
#	USE_TWISTED=1 python -m pytest -s -v autobahn/wamp/test/test_router.py
#	USE_ASYNCIO=1 python -m pytest -s -v autobahn/wamp/test/test_router.py

test2:
#	USE_TWISTED=1 python -m pytest -s -v autobahn/wamp/test/test_router.py
	USE_ASYNCIO=1 python -m pytest -s -v autobahn/wamp/test/test_router.py
#	trial autobahn
#	trial autobahn.websocket.test
#	trial autobahn.wamp.test
#	trial autobahn.wamp.test.test_component
#	trial autobahn.wamp.test.test_message
#	trial autobahn.wamp.test.test_protocol
#	trial autobahn.wamp.test.test_protocol_peer
#	trial autobahn.wamp.test.test_serializer
#	trial autobahn.wamp.test.test_uri_pattern

pyflakes:
	pyflakes .

# run PEP8 check and print statistics
pep8:
	pep8 --statistics --ignore=E501 -qq autobahn

# run PEP8 check and show source for offending code
pep8show:
	pep8 --show-source --ignore=E501 autobahn

# run autopep8 to automatically transform offending code
autopep8:
	autopep8 -ri --aggressive autobahn

# This will run pep8, pyflakes and can skip lines that end with # noqa
flake8:
	tox -c tox.ini -e flake8

# run PyLint
pylint:
	pylint -d line-too-long,invalid-name autobahn

# on Unix, check for files with Windows line endings
find_windows_files:
	find . -name "*" -exec file {} \; | grep "CRLF"

# on Windows (Git Bash), check for files with Unix lines endings
find_unix_files:
	find . -name "*" -exec dos2unix -tv {} \; 2>&1 | grep "Unix"

# sudo apt install gource ffmpeg
gource:
	gource \
	--path . \
	--seconds-per-day 0.15 \
	--title "autobahn-python" \
	-1280x720 \
	--file-idle-time 0 \
	--auto-skip-seconds 0.75 \
	--multi-sampling \
	--stop-at-end \
	--highlight-users \
	--hide filenames,mouse,progress \
	--max-files 0 \
	--background-colour 000000 \
	--disable-bloom \
	--font-size 24 \
	--output-ppm-stream - \
	--output-framerate 30 \
	-o - \
	| ffmpeg \
	-y \
	-r 60 \
	-f image2pipe \
	-vcodec ppm \
	-i - \
	-vcodec libx264 \
	-preset ultrafast \
	-pix_fmt yuv420p \
	-crf 1 \
	-threads 0 \
	-bf 0 \
	autobahn-python.mp4

#
# generate (a special set of) WAMP message classes from FlatBuffers schema
#

# To build flatc from sourcces:
#
#  git clone https://github.com/google/flatbuffers.git
#  cd flatbuffers
#  git checkout v22.12.06
#  cmake -G "Unix Makefiles" -DCMAKE_BUILD_TYPE=Release
#  make
#  sudo cp ./flatc /usr/local/bin/flatc

# input .fbs files for schema
FBSFILES=./autobahn/wamp/flatbuffers/*.fbs

# flatc compiler to use
FLATC=flatc

clean_fbs:
	-rm -rf ./autobahn/wamp/gen/

build_fbs:
	# generate schema binary type library (*.bfbs files)
	$(FLATC) -o ./autobahn/wamp/gen/schema/ --binary --schema --bfbs-comments --bfbs-builtins $(FBSFILES)
	@find ./autobahn/wamp/gen/schema/ -name "*.bfbs" | wc -l

	# generate schema Python bindings (*.py files)
	$(FLATC) -o ./autobahn/wamp/gen/ --python $(FBSFILES)
	@touch ./autobahn/wamp/gen/__init__.py
	@find ./autobahn/wamp/gen/ -name "*.py" | wc -l

build_fbs_cpp:
	# generate schema C++ bindings (*.cpp/hpp files)
	$(FLATC) -o /tmp/gen-cpp/ --cpp $(FBSFILES)
	@find /tmp/gen-cpp/

build_fbs_rust:
	# generate schema Rust bindings (*.rs files)
	$(FLATC) -o /tmp/gen-rust/ --rust $(FBSFILES)
	@find /tmp/gen-rust/

fix_copyright:
	find . -type f -exec sed -i 's/Copyright (c) Crossbar.io Technologies GmbH/Copyright (c) typedef int GmbH/g' {} \;

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/autobahn.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/autobahn.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/autobahn"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/autobahn"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== examples/Makefile ===
pyflakes:
	pyflakes .

# run PEP8 check and print statistics
pep8:
	pep8 --statistics --ignore=E501 -qq .

# run PEP8 check and show source for offending code
pep8show:
	pep8 --show-source --ignore=E501 .

# pep8 --select=E231 --show-source

autopep8:
	autopep8 -ri --aggressive --ignore=E501 .

# This will run pep8, pyflakes and can skip lines that end with # noqa
flake8:
	flake8 --ignore=E501,E901 .
#	flake8 --ignore=E501,E901,F401,F403,F811,F821,F841 .

pylint:
	pylint -d line-too-long,invalid-name .

examples_rawsocket:
	AUTOBAHN_DEMO_ROUTER=rs://127.0.0.1:8080 python run-all-examples.py

examples_websocket:
	AUTOBAHN_DEMO_ROUTER=ws://127.0.0.1:8080/ws python run-all-examples.py

examples: examples_websocket examples_rawsocket

=== wstest/Makefile ===
.PHONY: downloads

CURDIR := $(CURDIR)
REPORTDATE := `date -u +"%Y-%m-%d"`

AUTOBAHN_TESTSUITE_DOCKER := crossbario/autobahn-testsuite:0.8.2@sha256:5d4ba3aa7d6ab2fdbf6606f3f4ecbe4b66f205ce1cbc176d6cdf650157e52242

default:
	@echo 'targets: clean, downloads, build_wstest'


clean:
	-rm -rf ./reports
	-rm -rf ./venv*
	-rm -rf ./wstest

dist_clean: clean
	-rm -rf ./downloads

clean_reports:
	-rm -rf ./reports

# https://s3.eu-central-1.amazonaws.com/crossbario.com/reports/autobahn-testsuite-2021-03-16/clients/index.html
# https://crossbario.com/reports/autobahn-testsuite-2021-03-16/clients/index.html
upload_reports:
	./wstest/bin/aws s3 sync \
		--delete --acl public-read --region=eu-central-1 \
		reports \
		s3://crossbario.com/reports/autobahn-testsuite-$(REPORTDATE)


downloads:
	mkdir -p downloads
	wget -P downloads https://bootstrap.pypa.io/get-pip.py
	wget -P downloads https://downloads.python.org/pypy/pypy2.7-v7.3.3-linux64.tar.bz2
	wget -P downloads https://downloads.python.org/pypy/pypy3.7-v7.3.3-linux64.tar.bz2
	wget -P downloads https://www.python.org/ftp/python/2.7.18/Python-2.7.18.tar.xz
	wget -P downloads https://www.python.org/ftp/python/3.9.2/Python-3.9.2.tar.xz


# needs CPython 2 or PyPy 2, and https://pypi.org/project/autobahntestsuite/0.8.2/
build_wstest:
	mkdir -p ./wstest
	tar xvf ./downloads/pypy2.7-v7.3.3-linux64.tar.bz2 --strip-components=1 -C ./wstest
	./wstest/bin/pypy ./downloads/get-pip.py
	# ./wstest/bin/pip install -e ../../autobahn-testsuite/autobahntestsuite
	./wstest/bin/pip install "autobahntestsuite>=0.8.2"
	./wstest/bin/pip install awscli


build_pypy3:
	rm -rf ./pypy3
	mkdir -p ./pypy3
	tar xvf ./downloads/pypy3.7-v7.3.3-linux64.tar.bz2 --strip-components=1 -C ./pypy3
	cd ./pypy3/bin && ln -s pypy3 python && cd ../..
	./pypy3/bin/python ./downloads/get-pip.py
	./pypy3/bin/pip install virtualenv
	./pypy3/bin/python -V

build_cpy3:
	rm -rf ./cpy3_build
	mkdir -p ./cpy3_build
	tar xvf ./downloads/Python-3.9.2.tar.xz --strip-components=1 -C ./cpy3_build
	cd ./cpy3_build && ./configure --prefix=${CURDIR}/cpy3 && make && make install
	rm -rf ./cpy3_build
	./cpy3/bin/pip install virtualenv
	./cpy3/bin/python -V

build: build_wstest \
	   build_pypy3 \
	   build_cpy3


setup_pypy3_tx:
	./pypy3/bin/virtualenv ./venv_pypy3_tx
	cd .. && ./wstest/venv_pypy3_tx/bin/pip install -e .[twisted,compress]

setup_pypy3_aio:
	./pypy3/bin/virtualenv ./venv_pypy3_aio
	cd .. && ./wstest/venv_pypy3_aio/bin/pip install -e .[asyncio,compress]

setup_cpy3_tx:
	./cpy3/bin/virtualenv ./venv_cpy3_tx
	cd .. && ./wstest/venv_cpy3_tx/bin/pip install -e .[accelerate,twisted,compress]

setup_cpy3_aio:
	./cpy3/bin/virtualenv ./venv_cpy3_aio
	cd .. && ./wstest/venv_cpy3_aio/bin/pip install -e .[accelerate,asyncio,compress]

setup: setup_pypy3_tx setup_pypy3_aio setup_cpy3_tx setup_cpy3_aio


versions:
	@echo ""
	@echo "wstest (uses PyPy 2):"
	@echo ""
	./wstest/bin/pypy -V

	@echo ""
	@echo "CPython 3:"
	@echo ""
	./cpy3/bin/python -V
	@echo "Autobahn - CPython 3 / Twisted:"
	@./venv_cpy3_tx/bin/python -c "import autobahn; print('autobahn-{}'.format(autobahn.__version__))"
	@echo "Autobahn - CPython 3 / asyncio:"
	@./venv_cpy3_aio/bin/python -c "import autobahn; print('autobahn-{}'.format(autobahn.__version__))"

	@echo ""
	@echo "PyPy 3:"
	@echo ""
	./pypy3/bin/python -V
	@echo "Autobahn - PyPy 3 / Twisted:"
	@./venv_pypy3_tx/bin/python -c "import autobahn; print('autobahn-{}'.format(autobahn.__version__))"
	@echo "Autobahn - PyPy 3 / asyncio:"
	@./venv_pypy3_aio/bin/python -c "import autobahn; print('autobahn-{}'.format(autobahn.__version__))"


wstest_server_full:
	./wstest/bin/wstest -m fuzzingserver --spec=fuzzingserver-full.json

wstest_server_quick:
	./wstest/bin/wstest -m fuzzingserver --spec=fuzzingserver-quick.json


wstest_server_docker_pull:
	docker pull $(AUTOBAHN_TESTSUITE_DOCKER)

wstest_server_docker_stop:
	-docker rm --force fuzzingserver

wstest_server_docker_full:
	docker run -d --rm \
		--name fuzzingserver \
		-v ${PWD}/fuzzingserver-full.json:/config/fuzzingserver.json:ro \
		-v ${PWD}/reports:/reports \
		-p 9001:9001 \
		$(AUTOBAHN_TESTSUITE_DOCKER)

wstest_server_docker_quick:
	docker run -d --rm \
		--name fuzzingserver \
		-u `id -u`:`id -g` \
		-v ${PWD}/fuzzingserver-quick.json:/config/fuzzingserver.json:ro \
		-v ${PWD}/reports:/reports \
		-p 9001:9001 \
		$(AUTOBAHN_TESTSUITE_DOCKER)


test_pypy3_tx_client:
	./venv_pypy3_tx/bin/python testee_client_tx.py

test_pypy3_aio_client:
	./venv_pypy3_tx/bin/python testee_client_aio.py

test_cpy3_tx_client:
	./venv_cpy3_tx/bin/python testee_client_tx.py

test_cpy3_aio_client:
	./venv_cpy3_tx/bin/python testee_client_aio.py

test_tx_clients: \
	test_pypy3_tx_client \
	test_cpy3_tx_client

test_aio_clients: \
	test_pypy3_aio_client \
	test_cpy3_aio_client

test_clients: \
	test_tx_clients \
	test_aio_clients


start_cpy3_tx_server:
	./venv_cpy3_tx/bin/python testee_server_tx.py --url ws://127.0.0.1:9011 &

start_pypy3_tx_server:
	./venv_pypy3_tx/bin/python testee_server_tx.py --url ws://127.0.0.1:9013 &

start_cpy3_aio_server:
	./venv_cpy3_aio/bin/python testee_server_aio.py --url ws://127.0.0.1:9015 &

start_pypy3_aio_server:
	./venv_pypy3_aio/bin/python testee_server_aio.py --url ws://127.0.0.1:9017 &

start_tx_servers: \
	start_cpy3_tx_server \
	start_pypy3_tx_server

start_aio_servers: \
	start_cpy3_aio_server \
	start_pypy3_aio_server

start_servers: \
	start_tx_servers \
	start_aio_servers

stop_servers:
	-pkill -f "testee_server*"


# test individual server flavor - note that this will only
# produce a single report each, and it cannot be combined into
# a single report! here is the comment from wstest.py

# allow overriding servers from command line option, providing 1 server
# this is semi-useful, as you cannot accumulate a combined report for
# multiple servers by running wstest over and over again. the generated
# report is only for the last invocation - it would require a massive
# code restructering / rewriting to change that. no time for that unfort.

test_cpy3_tx_server:
	./wstest/bin/wstest -m fuzzingclient --spec=fuzzingclient-quick.json -w ws://127.0.0.1:9011

test_pypy3_tx_server:
	./wstest/bin/wstest -m fuzzingclient --spec=fuzzingclient-quick.json -w ws://127.0.0.1:9013

test_cpy3_aio_server:
	./wstest/bin/wstest -m fuzzingclient --spec=fuzzingclient-quick.json -w ws://127.0.0.1:9015

test_pypy3_aio_server:
	./wstest/bin/wstest -m fuzzingclient --spec=fuzzingclient-quick.json -w ws://127.0.0.1:9017

test_tx_servers: \
	test_cpy3_tx_server \
	test_pypy3_tx_server

test_aio_servers: \
	test_cpy3_aio_server \
	test_pypy3_aio_server

# THIS DOES NOT WORK TO PRODUCE THE FINAL COMBINED REPORT FOR ALL SERVERS!
# see above.
#test_server: \
#	test_tx_servers \
#	test_aio_servers


test_servers:
	./wstest/bin/wstest -m fuzzingclient --spec=fuzzingclient-quick.json

=== examples/xbr/Makefile ===
connect:
	python test_connect.py --gateway http://localhost:1545

typed:
	python test_typed.py --gateway http://localhost:1545

transfer:
	python test_transfer_tokens.py --gateway http://localhost:1545

register:
	python test_register.py --gateway http://localhost:1545

market:
	python test_market.py --gateway http://localhost:1545

domain:
	python test_domain.py --gateway http://localhost:1545

payment_channel:
	python test_payment_channel.py --gateway http://localhost:1545

sbc_connect:
	python test_sbc_connect.py --gateway http://localhost:1545 --adr "0x90f8bf6a479f320ead074411a4b0e7944ea8c9c1"
	python test_sbc_connect.py --gateway http://localhost:1545 --adr "0xFFcf8FDEE72ac11b5c542428B35EEF5769C409f0"

=== autobahn/xbr/test/catalog/Makefile ===
BUILD_DIR=./build
FBS_FILES=./src/*.fbs
FBS_OUTPUT=./schema

# https://blog.infura.io/post/ipfs-file-upload-client-tool
setup_ipfs_client_tool:
	wget https://github.com/INFURA/ipfs-upload-client/releases/download/v0.1.1/ipfs-upload-client-v0.1.1-linux-amd64.tar.gz
	tar xvf ipfs-upload-client-v0.1.1-linux-amd64.tar.gz
	sudo cp ipfs-upload-client /usr/local/bin/

# https://github.com/KittyHawkCorp/stripzip
# https://linux.die.net/man/1/zip
setup_stripzip:
	cd /tmp && git clone https://github.com/KittyHawkCorp/stripzip.git && cd stripzip && make && sudo cp ./stripzip /usr/local/bin/

clean:
	rm -rf $(BUILD_DIR)
	@mkdir -p $(BUILD_DIR)/schema
	@mkdir -p $(BUILD_DIR)/img
	find $(BUILD_DIR)

distclean: clean
	rm -rf $(FBS_OUTPUT)
	mkdir $(FBS_OUTPUT)

compile:
	flatc -o $(FBS_OUTPUT) --binary --schema --bfbs-comments --bfbs-builtins $(FBS_FILES)

# demo.bfbs  testsvc1.bfbs  wamp-auth.bfbs  wamp.bfbs  wamp-control.bfbs  wamp-meta.bfbs
describe:
	xbrnetwork describe-schema --schema $(FBS_OUTPUT)/demo.bfbs

# IMPORTANT: note the use of "-X" and stripzip to preserve privacy and support repeatable builds
build: compile
	@cp catalog.yaml $(BUILD_DIR)/
	@cp $(FBS_OUTPUT)/*.bfbs $(BUILD_DIR)/schema/
	@cp LICENSE.txt $(BUILD_DIR)/
	@cp README.md $(BUILD_DIR)/
	@cp img/*.png $(BUILD_DIR)/img/
	@cd $(BUILD_DIR) && zip -9 -X -r demo .
	@stripzip $(BUILD_DIR)/demo.zip
	@du -hs $(BUILD_DIR)/demo.zip
	@openssl sha256 $(BUILD_DIR)/demo.zip

publish:
	ipfs-upload-client --id ${INFURA_IPFS_PROJECT_ID} --secret ${INFURA_IPFS_PROJECT_SECRET} \
		$(BUILD_DIR)/demo.zip

publish_curl:
	curl "https://ipfs.infura.io:5001/api/v0/add?pin=false" \
		-X POST \
		-H "Content-Type: multipart/form-data" \
		-F file=@$(BUILD_DIR)/demo.zip

fetch_catalog:
	@rm -f /tmp/demo.zip
	@curl -X POST --output /tmp/demo.zip \
		https://ipfs.infura.io:5001/api/v0/cat?arg=QmdaWNrsnsQcYxLxMP6bjP2wj5Mjtd7aez8RnnJWZ4uzyJ
	openssl sha256 /tmp/demo.zip
	openssl sha256 $(BUILD_DIR)/demo.zip

=== examples/twisted/websocket/echo_variants/Makefile ===
client:
	PYTHONPATH=../../../../autobahn python client.py ws://127.0.0.1:9000

=== examples/twisted/websocket/wrapping/Makefile ===
test_server:
	PYTHONPATH=../../../../autobahn python server.py

test_client:
	PYTHONPATH=../../../../autobahn python client.py

=== debian/changelog ===
python-autobahn (24.4.2+dfsg1-2) unstable; urgency=medium

  * Uploading to unstable (Closes: #1115802).
  * Add patch-upstream-pytest.ini.patch.
  * Add make-test-function-async.patch.
  * Blacklist test_websocket_custom_loop.

 -- Thomas Goirand <zigo@debian.org>  Fri, 26 Sep 2025 11:18:49 +0200

python-autobahn (24.4.2+dfsg1-1) experimental; urgency=medium

  * New upstream release.

 -- Thomas Goirand <zigo@debian.org>  Wed, 27 Aug 2025 15:16:35 +0200

=== debian/control ===
Source: python-autobahn
Section: python
Priority: optional
Maintainer: Debian OpenStack <team+openstack@tracker.debian.org>
Uploaders:
 Thomas Goirand <zigo@debian.org>,
Build-Depends:
 debhelper-compat (= 10),
 dh-python,
 openstack-pkg-tools,
 python3-all,
 python3-setuptools,
 python3-sphinx,
 python3-sphinx-rtd-theme,
Build-Depends-Indep:
 python3-attr,
 python3-base58,
 python3-cbor,
 python3-cffi,
 python3-cryptography,
 python3-ecdsa,
 python3-flatbuffers,
 python3-enchant,
 python3-hyperlink,
 python3-lz4,
 python3-mnemonic,
 python3-msgpack,
 python3-nacl,
 python3-openssl,
 python3-passlib,
 python3-pyqrcode,
 python3-pytest,
 python3-pytest-asyncio,
 python3-service-identity,
 python3-snappy,
 python3-trie,
 python3-twisted,
 python3-txaio,
 python3-u-msgpack,
 python3-ubjson,
 python3-ujson,
 python3-wsaccel,
 python3-zope.interface,
Standards-Version: 4.1.1
Vcs-Browser: https://salsa.debian.org/openstack-team/python/python-autobahn
Vcs-Git: https://salsa.debian.org/openstack-team/python/python-autobahn.git
Homepage: http://autobahn.ws/python

Package: python3-autobahn
Architecture: all
Depends:
 python3-attr,
 python3-base58,
 python3-cbor,
 python3-cffi,
 python3-cryptography,
 python3-ecdsa,
 python3-flatbuffers,
 python3-hyperlink,
 python3-lz4,
 python3-mnemonic,
 python3-msgpack,
 python3-nacl,
 python3-openssl,
 python3-passlib,
 python3-pyqrcode,
 python3-service-identity,
 python3-snappy,
 python3-trie,
 python3-twisted,
 python3-txaio,
 python3-u-msgpack,
 python3-ubjson,
 python3-ujson,
 python3-wsaccel,
 python3-zope.interface,
 ${misc:Depends},
 ${python3:Depends},
Description: WebSocket client and server library, WAMP framework - Python 3.x
 Autobahn|Python is a networking library that is part of the Autobahn project
 and provides implementations of:
  * The WebSocket Protocol
  * The Web Application Messaging Protocol (WAMP)
 for Twisted and asyncio, on Python 2 & 3 and for writing servers and clients.
 .
 WebSocket allows bidirectional real-time messaging on the Web and WAMP adds
 asynchronous Remote Procedure Calls and Publish & Subscribe on top of
 WebSocket.
 .
 This package contains the Python 3.x module.

=== debian/rules ===
#!/usr/bin/make -f

UPSTREAM_GIT := https://github.com/crossbario/autobahn-python
include /usr/share/openstack-pkg-tools/pkgos.make

# Needed for tests:
export PYUBJSON_NO_EXTENSION=1
export AUTOBAHN_USE_NVX=0
export AUTOBAHN_USE_UJSON=1
export AUTOBAHN_USE_CBOR2=0
export USE_ASYNCIO=1

%:
	dh $@ --buildsystem=pybuild --with python3

override_dh_auto_clean:
	rm -rf twisted/plugins/dropin.cache
	rm -rf build .stestr .pytest_cache *.egg-info
	find . -iname '*.pyc' -delete
	for i in $$(find . -type d -iname __pycache__) ; do rm -rf $$i ; done

override_dh_auto_build:
	echo "Do nothing..."

override_dh_auto_install:
	pkgos-dh_auto_install --no-py2 --in-tmp

override_dh_auto_test:
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	set -e ; set -x ; for i in $(PYTHON3S) ; do \
		rm -rf build ; \
		PYTHONPATH=. python$$i -m pytest -Wignore -v \
			--ignore=./autobahn/twisted \
			--ignore=./autobahn/wamp \
			--ignore=./autobahn/websocket \
			--ignore=./autobahn/xbr \
			autobahn \
			-k 'not test_wamp_server and not test_websocket_custom_loop' \
			--asyncio-mode=auto ; \
	done
endif

override_dh_python3:
	dh_python3 --shebang=/usr/bin/python3

=== debian/tests/control ===
Tests: unittests
Depends:
 @builddeps@,
Restrictions: allow-stderr needs-root

=== debian/watch ===
version=3
opts="dversionmangle=s/\+dfsg\d//" \
https://github.com/tavendo/AutobahnPython/tags .*/v(\d[\d\.]+)\.tar\.gz
